#ifdef __cplusplus
extern "C" {
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifdef __cplusplus
}
#endif

#include "../src/rrd_tool.h"
#include "../src/rrd_statsl.h"
/* perl 5.004 compatibility */
#ifndef PL_sv_undef
#define PL_sv_undef sv_undef
#endif

#define rrdcode(name) \
		argv = (char **) malloc((items+1)*sizeof(char *));\
		argv[0] = "dummy";\
		for (i = 0; i < items; i++) { \
		    STRLEN len; \
		    char *handle= SvPV(ST(i),len);\
		    /* actually copy the data to make sure possible modifications \
		       on the argv data does not backfire into perl */ \
		    argv[i+1] = (char *) malloc((strlen(handle)+1)*sizeof(char)); \
		    strcpy(argv[i+1],handle); \
 	        } \
		optind=0; opterr=0; \
		rrd_clear_error();\
		RETVAL=name(items+1,argv); \
		for (i=0; i < items; i++) {\
		    free(argv[i+1]);\
		} \
		free(argv);\
		\
		if (rrd_test_error()) XSRETURN_UNDEF;


#ifdef WIN32
 #define free free
 #define malloc malloc
 #define realloc realloc
#endif /*WIN32*/


MODULE = RRDs	PACKAGE = RRDs	PREFIX = rrd_

BOOT:
#ifdef MUST_DISABLE_SIGFPE
	signal(SIGFPE,SIG_IGN);
#endif
#ifdef MUST_DISABLE_FPMASK
	fpsetmask(0);
#endif 

void
rrd_stats(...)
      PROTOTYPE: @
      PREINIT:
      int i, ii;
	  char * str;
      char **argv;
	  struct stats_values *psv, *remind_psv;
      PPCODE:
		{

			argv = (char **) malloc((items+1)*sizeof(char *));
			argv[0] = "dummy";
			for (i = 0; i < items; i++) { 
				STRLEN len;
				char *handle = SvPV(ST(i),len);
				/* actually copy the data to make sure possible modifications
				   on the argv data does not backfire into perl */ 
				argv[i+1] = (char *) malloc((strlen(handle)+1)*sizeof(char));
				strcpy(argv[i+1],handle);
				//printf ( " arg [%i] val [%s]\n", i+1, argv[i+1] );
			}
			optind=0; opterr=0; 
			rrd_clear_error();
			ii = rrd_stats(items+1,argv, &psv);
			remind_psv=psv;
			for (i=0; i < items; i++) {
				free(argv[i+1]);
			}
			free(argv);
			
			//printf ( " ii = [%i]\n", ii );
			if ( ii == 1) {
				if (rrd_test_error()) {
					free_psv ( psv );
					XSRETURN_UNDEF;
				}
				while ( psv != NULL ) {
					//printf ( " psv->nbvals = [%i]\n", psv->nbvals );
					if ( psv->nbvals > 0 ) {
						//printf ( "[%i] multiple values [%c] ", psv->nbvals, psv->datatype );
						switch (psv->datatype) {
						case 'I':	{
										AV *strs=newAV();
										int * results = (int *) psv->val.ptr;
										for (ii=0; ii < psv->nbvals; ii++ ) {
										    av_push(strs,newSViv(results[ii]));
										}
										EXTEND(sp,1);
										PUSHs(sv_2mortal(newRV_noinc((SV*)strs)));
										break;
									}
						case 'S':	{
										AV *strs=newAV();
										char ** str = (char **) psv->val.ptr;
										for (ii=0; ii < psv->nbvals; ii++ ) {
										    av_push(strs,newSVpv(str[ii],0));
										}
										EXTEND(sp,1);
										PUSHs(sv_2mortal(newRV_noinc((SV*)strs)));
										break;
									}
						case 'D':	{
										AV *strs=newAV();
										double * results = (double *) psv->val.ptr;
										for (ii=0; ii < psv->nbvals; ii++ ) {
										    av_push(strs,newSVnv(results[ii]));
										}
										EXTEND(sp,1);
										PUSHs(sv_2mortal(newRV_noinc((SV*)strs)));
										break;
									}
						default: break;
						}
						//printf ( "\n" );
					} else {
						//printf ( "single value [%c] ", psv->datatype );
						switch (psv->datatype) {
						case 'i':	
							EXTEND(sp,1);
							PUSHs(sv_2mortal(newSViv(psv->val.i)));
							break;
						case 's':	
							EXTEND(sp,1);
							PUSHs(sv_2mortal(newSVpv(psv->val.str,0)));
							break;
						case 'd':	
							EXTEND(sp,1);
							PUSHs(sv_2mortal(newSVnv(psv->val.d)));
							break;
						default: break;
						}
						//printf ( "\n" );
					}
					psv = psv->pnext;
				}
				free_psv ( remind_psv );
			} else {
				XSRETURN_UNDEF;
			}
		}	

SV*
rrd_error()
	CODE:
		if (! rrd_test_error()) XSRETURN_UNDEF;
                RETVAL = newSVpv(rrd_get_error(),0);
	OUTPUT:
		RETVAL

	
int
rrd_last(...)
      PROTOTYPE: @
      PREINIT:
      int i;
      char **argv;
      CODE:
              rrdcode(rrd_last);
      OUTPUT:
            RETVAL


int
rrd_create(...)
	PROTOTYPE: @	
	PREINIT:
        int i;
	char **argv;
	CODE:
		rrdcode(rrd_create);
	        RETVAL = 1;
        OUTPUT:
		RETVAL


int
rrd_update(...)
	PROTOTYPE: @	
	PREINIT:
        int i;
	char **argv;
	CODE:
		rrdcode(rrd_update);
       	        RETVAL = 1;
	OUTPUT:
		RETVAL


int
rrd_tune(...)
	PROTOTYPE: @	
	PREINIT:
        int i;
	char **argv;
	CODE:
		rrdcode(rrd_tune);
       	        RETVAL = 1;
	OUTPUT:
		RETVAL


void
rrd_graph(...)
	PROTOTYPE: @	
	PREINIT:
	char **calcpr;
	int i,xsize,ysize;
	char **argv;
	AV *retar;
	PPCODE:
		argv = (char **) malloc((items+1)*sizeof(char *));
		argv[0] = "dummy";
		for (i = 0; i < items; i++) { 
		    STRLEN len;
		    char *handle = SvPV(ST(i),len);
		    /* actually copy the data to make sure possible modifications
		       on the argv data does not backfire into perl */ 
		    argv[i+1] = (char *) malloc((strlen(handle)+1)*sizeof(char));
		    strcpy(argv[i+1],handle);
 	        }
		optind=0; opterr=0; 
		rrd_clear_error();
		rrd_graph(items+1,argv,&calcpr,&xsize,&ysize); 
		for (i=0; i < items; i++) {
		    free(argv[i+1]);
		}
		free(argv);

		if (rrd_test_error()) {
			if(calcpr)
			   for(i=0;calcpr[i];i++)
				free(calcpr[i]);
			XSRETURN_UNDEF;
		}
		retar=newAV();
		if(calcpr){
			for(i=0;calcpr[i];i++){
				 av_push(retar,newSVpv(calcpr[i],0));
				 free(calcpr[i]);
			}
			free(calcpr);
		}
		EXTEND(sp,4);
		PUSHs(sv_2mortal(newRV_noinc((SV*)retar)));
		PUSHs(sv_2mortal(newSViv(xsize)));
		PUSHs(sv_2mortal(newSViv(ysize)));

void
rrd_fetch(...)
	PROTOTYPE: @	
	PREINIT:
		time_t        start,end;		
		unsigned long step, ds_cnt,i,ii;
		rrd_value_t   *data,*datai;
		char **argv;
		char **ds_namv;
		AV *retar,*line,*names;
	PPCODE:
		argv = (char **) malloc((items+1)*sizeof(char *));
		argv[0] = "dummy";
		for (i = 0; i < items; i++) { 
		    STRLEN len;
		    char *handle= SvPV(ST(i),len);
		    /* actually copy the data to make sure possible modifications
		       on the argv data does not backfire into perl */ 
		    argv[i+1] = (char *) malloc((strlen(handle)+1)*sizeof(char));
		    strcpy(argv[i+1],handle);
 	        }
		optind=0; opterr=0; 
		rrd_clear_error();
		rrd_fetch(items+1,argv,&start,&end,&step,&ds_cnt,&ds_namv,&data); 
		for (i=0; i < items; i++) {
		    free(argv[i+1]);
		}
		free(argv);
		if (rrd_test_error()) XSRETURN_UNDEF;
                /* convert the ds_namv into perl format */
		names=newAV();
		for (ii = 0; ii < ds_cnt; ii++){
		    av_push(names,newSVpv(ds_namv[ii],0));
		    free(ds_namv[ii]);
		}
		free(ds_namv);			
		/* convert the data array into perl format */
		datai=data;
		retar=newAV();
		for (i = start; i <= end; i += step){
			line = newAV();
			for (ii = 0; ii < ds_cnt; ii++){
 			  av_push(line,(isnan(*datai) ? &PL_sv_undef : newSVnv(*datai)));
			  datai++;
			}
			av_push(retar,newRV_noinc((SV*)line));
		}
		free(data);
		EXTEND(sp,5);
		PUSHs(sv_2mortal(newSViv(start)));
		PUSHs(sv_2mortal(newSViv(step)));
		PUSHs(sv_2mortal(newRV_noinc((SV*)names)));
		PUSHs(sv_2mortal(newRV_noinc((SV*)retar)));


SV*
rrd_info(...)
	PROTOTYPE: @	
	PREINIT:
		info_t *data,*save;
                int i;
                char **argv;
		HV *hash;
	CODE:
		/* prepare argument list */
		argv = (char **) malloc((items+1)*sizeof(char *));
		argv[0] = "dummy";
		for (i = 0; i < items; i++) { 
		    STRLEN len;
		    char *handle= SvPV(ST(i),len);
		    /* actually copy the data to make sure possible modifications
		       on the argv data does not backfire into perl */ 
		    argv[i+1] = (char *) malloc((strlen(handle)+1)*sizeof(char));
		    strcpy(argv[i+1],handle);
 	        }
		optind=0; opterr=0; 
                rrd_clear_error();
                data=rrd_info(items+1, argv);
                for (i=0; i < items; i++) {
		    free(argv[i+1]);
		}
		free(argv);
                if (rrd_test_error()) XSRETURN_UNDEF;
                hash = newHV();
                while (data) {
		    save=data;
		/* the newSV will get copied by hv so we create it as a mortal to make sure
                   it does not keep hanging round after the fact */
#define hvs(VAL) hv_store_ent(hash, sv_2mortal(newSVpv(data->key,0)),VAL,0)		    
		    switch (data->type) {
		    case RD_I_VAL:
			if (isnan(data->value.u_val))
			    hvs(&PL_sv_undef);
			else
			    hvs(newSVnv(data->value.u_val));
			break;
		    case RD_I_CNT:
			hvs(newSViv(data->value.u_cnt));
			break;
		    case RD_I_STR:
			hvs(newSVpv(data->value.u_str,0));
			free(data->value.u_str);
			break;
		    }
#undefine hvs
		    free(data->key);
		    data = data->next;		    
		    free(save);
		}
                free(data);
                RETVAL = newRV_noinc((SV*)hash);
       OUTPUT:
		RETVAL


